﻿// Base Box component class
// Nearly all MCs are derived from this class
//
class Box extends MovieClip {
	public var b:Object;
	public var fill:Number;
	public var over:Number;
	public var shade:Number;
	public var outline:Number;
	public var selectCol:Number = 0xFFFF00;
	public var gridCol:Number = 0x33CC33;
	public var space:Number = 10;
	public var web2:Boolean = true;
	public var corn:Number = 10;
	public var designated:Boolean = false;
	public var xmlID:XMLNode;
	public function setBox(x:Number, y:Number, w:Number, h:Number, fill:Number, over:Number) {
		b = new Object();
		b = {x:x, y:y, w:w, h:h};
		this.fill = fill;
		this.over = over;
		drawBox(fill);
	}
	public function designate(yes:Boolean) {
		if (yes) {
			designated = true;
			drawBox(fill);
		} else {
			designated = false;
			drawBox(fill);
		}
	}
	public function drawBox(col) {
		this.clear();
		var thick = 0;
		var alpha = 0;
		if (designated) {
			thick = 2;
			alpha = 100;
		}
		this.lineStyle(thick, selectCol, alpha);
		this.beginFill(col, 100);
		if (!web2) {
			this.moveTo(b.x, b.y);
			this.lineTo(b.x + b.w, b.y);
			this.lineTo(b.x + b.w, b.y + b.h);
			this.lineTo(b.x, b.y + b.h);
			this.lineTo(b.x, b.y);
		} else {
			this.moveTo(b.x + corn, b.y);
			this.lineTo(b.x + b.w - corn, b.y);
			this.curveTo(b.x + b.w, b.y, b.x + b.w, b.y + corn);
			this.lineTo(b.x + b.w, b.y + b.h - corn);
			this.curveTo(b.x + b.w, b.y + b.h, b.x + b.w - corn, b.y + b.h);
			this.lineTo(b.x + corn, b.y + b.h);
			this.curveTo(b.x, b.y + b.h, b.x, b.y + b.h - corn);
			this.lineTo(b.x, b.y + corn);
			this.curveTo(b.x, b.y, b.x + corn, b.y);
		}
		this.endFill();
	}
	public function bx() {
		return b.x;
	}
	public function by() {
		return b.y;
	}
	public function bw() {
		return b.w;
	}
	public function hw() {
		return b.w * 0.5;
	}
	public function bh() {
		return b.h;
	}
	public function hh() {
		return b.h * 0.5;
	}
	public function grid(){
		lineStyle(0.25, gridCol);
		for(var i = b.x; i < b.x + b.w; i+=space){
			moveTo(i, b.y);
			lineTo(i, b.y + b.h);
		}
		for(var i = b.y; i < b.y + b.h; i+=space){
			moveTo(b.x, i);
			lineTo(b.x + b.w, i);
		}
	}
}
