﻿// Slideshow component
//
class CarouselBox extends Box {
	var MCL:MovieClipLoader;
	var preload:Object;
	var canvasWidth:Number = 0;
	var canvasHeight:Number = 0;
	var time:Number = 0.5;
	var ready:Boolean = false;
	// init
	function setCarousel(temp:XMLNode) {
		xmlID = temp;
		_x = parseInt(xmlID.attributes.x);
		_y = parseInt(xmlID.attributes.y);
		fill = parseInt(xmlID.attributes.boxFill, 16);
		shade = parseInt(xmlID.attributes.shadeFill, 16);
		MCL = new MovieClipLoader();
		preload = new Object();
		preload["parent"] = this;
		preload.onLoadStart = function(targetMC) {
			//trace("started loading " + targetMC);
		};
		preload.onLoadProgress = function(targetMC, lBytes, tBytes) {
			this["parent"]["loadBar"].setPercent(lBytes, tBytes);
		};
		preload.onLoadComplete = function(targetMC) {
			//trace(targetMC + " finished");
			this["parent"]["mount"]._visible = true;
			this["parent"]._parent["carouselControl"].timed = true;
			this["parent"]._parent["carouselControl"].timer = 0;
			var fadeCanvas = new mx.transitions.Tween(this["parent"]["mount"], "_alpha", mx.transitions.easing.Strong.easeIn, 0, 100, this["parent"].time, true);
			var fadeBar = new mx.transitions.Tween(this["parent"]["loadBar"], "_alpha", mx.transitions.easing.Strong.easeIn, 100, 0, this["parent"].time, true);
			
		};
		MCL.addListener(preload);
		this.attachMovie("Box", "mount", 1);
		this["mount"].createEmptyMovieClip("canvas", 3);
		attachMovie("LoadBar", "loadBar", 5);
		this["loadBar"].setBar(-100, -10, 200, 20, shade, fill);
		this["loadBar"]._visible = false;
		this["mount"]._visible = false;
		this["mount"]._alpha = 0;
		_parent["consoleBox"].report("CarouselBox mounted and initialised");
		ready = true;
	}
	function reDraw(){
		this["mount"].drawBox(fill);
		this["loadBar"].fill = shade;
		this["loadBar"].over = fill;
		this["loadBar"].drawBox(shade);
	}
	function loadUrl(file:String) {
		_parent["consoleBox"].report("Loading image ("+file+")");
		this["loadBar"]._visible = true;
		this["loadBar"]._alpha = 0;
		this["loadBar"].setPercent(0, 10);
		var fade = new mx.transitions.Tween(this["loadBar"], "_alpha", mx.transitions.easing.Strong.easeInOut, 0, 100, time, true);
		if(this["mount"]._alpha > 0){
			var fadeCanvas = new mx.transitions.Tween(this["mount"], "_alpha", mx.transitions.easing.Strong.easeInOut, this["mount"]._alpha, 0, time, true);
			fadeCanvas["parent"] = this;
			fadeCanvas.onMotionFinished = function(){
				this["parent"].MCL.loadClip(file, this["parent"]["mount"]["canvas"]);;
			};
		} else {
			MCL.loadClip(file, this["mount"]["canvas"]);
		}
	}
	function onEnterFrame() {
		moveCanvas();
	}
	function designate(yes:Boolean){
		this["mount"].designate(yes);
		designated = yes;
	}
	// Repositioning function to keep content centered
	// Patches periods of MC size blindness during loading
	function moveCanvas() {
		var moved = false;
		if (this["mount"]["canvas"]._width != canvasWidth) {
			this["mount"]["canvas"]._x = -(this["mount"]["canvas"]._width * 0.5);
			canvasWidth = this["mount"]["canvas"]._width;
			moved = true;
		}
		if (this["mount"]["canvas"]._height != canvasHeight) {
			this["mount"]["canvas"]._y = -(this["mount"]["canvas"]._height * 0.5);
			canvasHeight = this["mount"]["canvas"]._height;
			moved = true;
		}
		this["mount"].setBox(-space - (canvasWidth * 0.5), -space - (canvasHeight * 0.5), canvasWidth + space * 2, canvasHeight + space * 2, fill, fill);
	}
}
