﻿// SlideShow controller
//
class CarouselControl extends MovieClip {
	var urlList:Array;
	var urlIcon:Array;
	var focus:Number = 0;
	var size:Number = 15;
	var fill:Number;
	var over:Number;
	var item:Number = 0;
	var arrowFill:Number;
	var space:Number = 10;
	var designated = false;
	var timer:Number = 0;
	var timed:Boolean = false;
	var xmlID:XMLNode;
	var ready:Boolean = false;
	function setCarouselControl(temp:XMLNode) {
		xmlID = temp;
		_x = parseInt(xmlID.attributes.x);
		_y = parseInt(xmlID.attributes.y);
		fill = parseInt(xmlID.attributes.boxFill, 16);
		over = parseInt(xmlID.attributes.overFill, 16);
		arrowFill = parseInt(xmlID.attributes.arrowFill, 16);
		attachMovie("ArrowBox", "left", 3, {_x:-size});
		attachMovie("ArrowBox", "right", 5, {_x:size});
		attachMovie("Box", "itemBox", 1);
		this["left"].setBox(-size, -size, size * 2, size * 2, fill, over);
		this["left"].setArrow("left", arrowFill);
		this["right"].setBox(-size, -size, size * 2, size * 2, fill, over);
		this["right"].setArrow("right", arrowFill);
		this["left"].onRelease = function() {
			_parent.item = _parent.item - 1 < 0 ? _parent.urlIcon.length - 1 : _parent.item - 1;
			var time = 0.2;
			var slide = new mx.transitions.Tween(_parent["itemBox"], "_x", mx.transitions.easing.Strong.easeIn, _parent["itemBox"]._x, _parent.urlIcon[_parent.item]._x, time, true);
			_parent.loadItem(_parent.item);
			_parent.timer = 0;
		};
		this["left"].onRollOver = function() {
			this.drawBox(this.over);
			this.drawArrow(this.arrowFill);
			_parent.timed = false;
		}
		this["left"].onRollOut = function() {
			this.drawBox(this.fill);
			this.drawArrow(this.arrowFill);
			_parent.timed = true;
		}
		this["right"].onRelease = function() {
			_parent.item = (_parent.item + 1) % _parent.urlIcon.length;
			var time = 0.2;
			var slide = new mx.transitions.Tween(_parent["itemBox"], "_x", mx.transitions.easing.Strong.easeIn, _parent["itemBox"]._x, _parent.urlIcon[_parent.item]._x, time, true);
			_parent.loadItem(_parent.item);
			_parent.timer = 0;
		};
		this["right"].onRollOver = function() {
			this.drawBox(this.over);
			this.drawArrow(this.arrowFill);
			_parent.timed = false;
		}
		this["right"].onRollOut = function() {
			this.drawBox(this.fill);
			this.drawArrow(this.arrowFill);
			_parent.timed = true;
		}
		this["itemBox"].setBox(-size, -size * 1.5, size * 2, size * 3, arrowFill, arrowFill);
		_parent["consoleBox"].report("CarouselControl mounted and initialised");
		ready = true;
	}
	function reDraw() {
		this["left"].fill = fill;
		this["left"].over = over;
		this["left"].arrowFill = arrowFill;
		this["left"].drawBox(fill);
		this["left"].drawArrow(arrowFill);
		this["right"].fill = fill;
		this["right"].over = over;
		this["right"].arrowFill = arrowFill;
		this["right"].drawBox(fill);
		this["right"].drawArrow(arrowFill);
		this["itemBox"].fill = arrowFill;
		this["itemBox"].drawBox(arrowFill);
		for (var i in urlIcon) {
			urlIcon[i].fill = fill;
			urlIcon[i].over = over;
			urlIcon[i].arrowFill = arrowFill;
			urlIcon[i].drawBox(fill);
		}
	}
	function loadControl(urls:Array) {
		urlList = urls;
		focus = 0;
		setUrlIcons(urlList.length);
	}
	function loadItem(num:Number) {
		timed = false;
		_parent["carouselBox"].loadUrl(urlList[num]);
	}
	function setUrlIcons(num:Number) {
		for (var i in urlIcon) {
			urlIcon[i].removeMovieClip();
		}
		urlIcon = new Array();
		for (var i = 0; i < num; i++) {
			urlIcon.push(attachMovie("Box", "box" + i, this.getNextHighestDepth()));
			urlIcon[urlIcon.length - 1].setBox(-size, -size, size * 2, size * 2, fill, over);
			urlIcon[urlIcon.length - 1]["num"] = i;
			urlIcon[i].onRelease = function() {
				var time = 0.5;
				_parent.loadItem(this["num"]);
				_parent.item = this["num"];
				var slide = new mx.transitions.Tween(_parent["itemBox"], "_x", mx.transitions.easing.Strong.easeIn, _parent["itemBox"]._x, this._x, time, true);
				_parent.timer = 0;
			};
			urlIcon[i].onRollOver = function() {
				this.drawBox(over);
				_parent.timed = false;
			};
			urlIcon[i].onRollOut = function() {
				this.drawBox(fill);
				_parent.timed = true;
			};
		}
		var totalWidth = ((num + 1) * size * 2) + ((num + 1) * space);
		num += 2;
		// Carousel controls
		var x0 = -totalWidth / 2;
		for (var i = 0; i < num; i++) {
			switch (i) {
			case 0 :
				this["left"]._x = x0;
				break;
			default :
				urlIcon[i - 1]._x = x0 + i * ((size * 2) + space);
				break;
			case num - 1 :
				this["right"]._x = x0 + i * ((size * 2) + space);
				break;
			}
		}
		var time = 0.2;
		var slide = new mx.transitions.Tween(this["itemBox"], "_x", mx.transitions.easing.Strong.easeIn, this["itemBox"]._x, urlIcon[0]._x, time, true);
		item = 0;
		loadItem(0);
	}
	function onEnterFrame(){
		if(urlIcon.length > 1 && timed){
			if(timer > 150){
				timer = 0;
				stepForward();
			} else {
				timer++;
			}
		}
	}
	function stepForward() {
		item = (item + 1) % urlIcon.length;
		var time = 0.2;
		var slide = new mx.transitions.Tween(this["itemBox"], "_x", mx.transitions.easing.Strong.easeIn, this["itemBox"]._x, urlIcon[item]._x, time, true);
		loadItem(item);
	}
	function designate(yes:Boolean) {
		designated = yes;
		for (var i in urlIcon) {
			urlIcon[i].designate(yes);
		}
		this["left"].designate(yes);
		this["right"].designate(yes);
	}
}
