﻿// Master MovieClip that is responsible for the whole movie
class LayoutBox extends Box {
	var asset:Array;
	var assetCount:Number;
	var xmlData:XML;
	var htmlData:XML;
	var keyListen:Object;
	var HTMLUrl:String = "";
	var handles:Boolean = false;
	var designatedAsset:MovieClip;
	var htmlColor:Number;
	var appletCol:Number;
	var assetTimer:Number;
	var css:TextField.StyleSheet;
	var ready:Boolean = false;
	function setLayout(file:String) {
		asset = new Array();
		asset.push(attachMovie("ConsoleBox", "consoleBox", 13));
		this["consoleBox"].setConsole();
		this["consoleBox"].report("LayoutBox mounted - (fingers crossed)");
		this["consoleBox"]._visible = false;
		css = new TextField.StyleSheet();
		css["parent"] = this;
		css.onLoad = function(success:Boolean) {
			if (success) {
				this["parent"]["consoleBox"].report("htmltext.css onLoad success");
			} else {
				this["parent"]["consoleBox"].report("htmltext.css onLoad faliure");
			}
		};
		xmlData = new XML();
		xmlData["parent"] = this;
		xmlData.onLoad = function(success:Boolean) {
			if (success) {
				this["parent"]["consoleBox"].report("layout.xml onLoad success");
				this["parent"].readXML();
			} else {
				this["parent"]["consoleBox"].report("layout.xml onLoad faliure");
			}
		};
		// Simple Keys
		keyListen = new Object();
		keyListen["parent"] = this;
		keyListen.onKeyDown = function() {
			switch (Key.getCode()) {
				// Turn handles on and off
			case 72 :
				// H
				this["parent"].switchHandles();
				break;
				// Hide / Show LayoutControl
			case 76 :
				// L
				this["parent"].switchLayoutControl();
				break;
				// Hide / Show Console
			case 67 :
				// C
				if (!this["parent"]["layoutControl"]._visible) {
					if (!this["parent"]["consoleBox"]._visible) {
						this["parent"]["consoleBox"]._visible = true;
						this["parent"]["consoleBox"].setText();
					} else {
						this["parent"]["consoleBox"]._visible = false;
					}
				}
				break;
				// Pause / Play Carousel auto play
			case 80 :
				// P
				this["parent"]["carouselControl"].timed = !this["parent"]["carouselControl"].timed;
				this["parent"]["consoleBox"].report("CarouselBox auto-play - " + this["parent"]["carouselControl"].timed);
				break;
			}
		};
		Key.addListener(keyListen);
		css.load("assets/htmltext.css");
		xmlData.load(file);
	}
	function switchLayoutControl() {
		if (this["layoutControl"]._visible) {
			this["layoutControl"].asset.designate(false);
			this["layoutControl"].asset = this;
			this["layoutControl"]._visible = false;
			if (handles) {
				switchHandles();
			}
			drawBox(fill);
		} else {
			this["layoutControl"].reDraw();
			this["layoutControl"]._visible = true;
			if (!handles) {
				switchHandles();
			}
		}
	}
	function switchHandles() {
		if (!handles) {
			for (var i in asset) {
				asset[i].attachMovie("BoxHandle", "handle" + i, asset[i].getNextHighestDepth());
				asset[i]["handle" + i].setHandle();
			}
			handles = true;
		} else {
			for (var i in asset) {
				asset[i]["handle" + i].removeMovieClip();
			}
			handles = false;
		}
	}
	public function reDraw() {
		backBox();
		this["backing"].setBox(0, 0, Stage.width, Stage.height, fill, fill);
	}
	public function backBox() {
		lineStyle(0, 0, 0);
		beginFill(htmlColor, 100);
		moveTo(0, 0);
		lineTo(Stage.width, 0);
		lineTo(Stage.width, Stage.height);
		lineTo(0, Stage.height);
		lineTo(0, 0);
		endFill();
	}
	public function readXML() {
		xmlData.ignoreWhite = true;
		var rootNode = xmlData.firstChild;
		if (rootNode.nodeName.toUpperCase() == "LAYOUT") {
			var myNode = rootNode.firstChild;
			while (myNode != null) {
				var movieName = "Box";
				var newName = "none";
				switch (myNode.nodeName.toUpperCase()) {
				case "DEFAULT" :
					htmlColor = parseInt(myNode.attributes.bgCol, 16);
					appletCol = parseInt(myNode.attributes.appletCol, 16);
					backBox();
					attachMovie("Box", "backing", 0);
					fill = parseInt(myNode.attributes.boxFill, 16);
					this["backing"].setBox(0, 0, Stage.width, Stage.height, fill, fill);
					break;
				case "MENUBOX" :
					movieName = "MenuBox";
					newName = "menuBox";
					asset.push(attachMovie(movieName, newName, 9));
					var menuXML = new XML();
					// Compensation for event-handler loss of focus
					menuXML["parent"] = this;
					menuXML["myNode"] = myNode;
					menuXML["myMenu"] = asset[asset.length - 1];
					menuXML.onLoad = function(success) {
						if (success) {
							this["parent"]["consoleBox"].report("menu.xml onLoad success");
							this["myMenu"].setContent(menuXML, this["myNode"]);
						} else {
							this["parent"]["consoleBox"].report("menu.xml onLoad faliure");
							trace("failed to load menuXML");
						}
					};
					menuXML.load("assets/menu.xml");
					break;
				case "CAROUSELBOX" :
					movieName = "CarouselBox";
					newName = "carouselBox";
					asset.push(attachMovie(movieName, newName, 3));
					asset[asset.length - 1].setCarousel(myNode);
					break;
				case "CAROUSELCONTROL" :
					movieName = "CarouselControl";
					newName = "carouselControl";
					asset.push(attachMovie(movieName, newName, 5));
					asset[asset.length - 1].setCarouselControl(myNode);
					break;
				case "TEXTAREABOX" :
					movieName = "TextAreaBox";
					newName = "textAreaBox";
					asset.push(attachMovie(movieName, newName, 7));
					asset[asset.length - 1].setArea(myNode);
					break;
				case "LAYOUTCONTROL" :
					movieName = "LayoutControl";
					newName = "layoutControl";
					asset.push(attachMovie(movieName, newName, 11));
					asset[asset.length - 1].setLayoutControl(myNode, this);
				}
				myNode = myNode.nextSibling;
			}
			// This part makes the movie wait for all the assets to call "ready"
			// then loads the default content
			assetTimer = setInterval(assetCheck, 500, this);
		}
	}
	function assetCheck(parent:MovieClip) {
		if (!parent.ready) {
			var total = 0;
			for (var i = 0; i < parent.asset.length; i++) {
				if (parent.asset[i].ready) {
					total++;
				}
			}
			if (parent.asset.length == total) {
				parent["consoleBox"].report("All assets initialised");
				// Check the browser address for a forced url or go straight to 'About'
				if(substring(_root.forceUrl, 0, 4) != "http" || _root.forceUrl == null){
					parent["menuBox"].changeFocus(0);
					parent.ready = true;
				} else {
					parent["consoleBox"].report("$_GET url request, redirecting...");
					parent.myGetUrl(_root.forceUrl);
					parent.ready = true;
				}
			}
		} else {
			clearInterval(parent.assetTimer);
		}
	}
	function myGetUrl(path) {
		this["consoleBox"].report("myGetUrl (" + path + ")");
		if (HTMLUrl != path || "") {
			HTMLUrl = path;
			// determine nature of file
			var fileDot = path.lastIndexOf(".");
			var fileType = path.substring(fileDot + 1, path.length).toUpperCase();
			switch (fileType) {
			case "JPG" :
			case "JPEG" :
			case "SWF" :
				var myImage = new Array();
				myImage[0] = path;
				this["carouselControl"].loadControl(myImage);
				break;
			case "XML" :
				this["textAreaBox"].setText('Requesting File...<br>please wait');
				htmlData = new XML();
				htmlData.ignoreWhite = true;
				htmlData["parent"] = this;
				htmlData.onLoad = function(success:Boolean) {
					if (success) {
						this["parent"]["consoleBox"].report("HTML onLoad success");
						this["parent"].HTML2Text(this, this["parent"].HTMLUrl);
					} else {
						this["parent"]["consoleBox"].report("XML onLoad faliure");
						trace("failed to load XML");
					}
				};
				htmlData.load(path);
				break;
			// Treat all other urls as html files to be wrapped
			default :
				this["textAreaBox"].setText('Requesting File...' + path + '<br>please wait');
				htmlData = new XML();
				htmlData.ignoreWhite = true;
				htmlData["parent"] = this;
				htmlData.onLoad = function(success:Boolean) {
					if (success) {
						this["parent"]["consoleBox"].report("HTML onLoad success");
						this["parent"].HTML2Text(this, this["parent"].HTMLUrl);
					} else {
						this["parent"]["consoleBox"].report("HTML onLoad faliure");
						trace("failed to load HTML");
					}
				};
				htmlData.load("http://www.robotacid.com:80/cgi-bin/xml_wrap.cgi?url=" + path);
				break;
			}
		}
	}
	function HTML2Text(HTML, HTMLUrl) {
		var imageStack = new Array();
		var myText = '';
		HTML.ignoreWhite = true;
		var rootNode = HTML.firstChild;
		if (rootNode.nodeName.toUpperCase() == "ROOT") {
			var myNode = rootNode.firstChild;
			while (myNode != null) {
				if (myNode.nodeName.toUpperCase() == "HTMLTEXT") {
					var textNode = myNode.firstChild;
					myText = textNode.nodeValue;
				}
				if (myNode.nodeName.toUpperCase() == "CAROUSEL") {
					var imgNode = myNode.firstChild;
					while (imgNode != null) {
						imageStack.push(imgNode.attributes.src);
						imgNode = imgNode.nextSibling;
					}
				}
				myNode = myNode.nextSibling;
			}
		}
		this["textAreaBox"].setText(myText);
		if (imageStack.length > 0) {
			this["carouselControl"].loadControl(imageStack);
		}
	}
	// Hack around for old PHP version of HTML grabbing
	function HTML2TextOld(HTML, HTMLUrl) { // <- DEPRECATED
		//trace(HTML.toString());
		var stack = new Array();
		var imageStack = new Array();
		var myText = '<font size="14" face="Arial" color="#333333">';
		var pCount = 0;
		var bCount = 0;
		var firstText = true;
		HTML.firstChild.visited = true;
		stack.push(HTML.firstChild);
		var HTMLUrlFolder = HTMLUrl.substr(0, HTMLUrl.lastIndexOf("/") + 1);
		while (stack.length > 0) {
			// Parse elements here
			if (stack[stack.length - 1].nodeType == 1) {
				if (stack[stack.length - 1].nodeName.toUpperCase() == "A") {
					stack[stack.length - 1].attributes.target = "_blank";
					var url = stack[stack.length - 1].attributes.href;
					if (url.substring(0, 5) != "http:" && url.substring(0, 6) != "mailto") {
						stack[stack.length - 1].attributes.href = HTMLUrlFolder + stack[stack.length - 1].attributes.href;
					}
					myText += '<u><font color="#0066CC">' + stack[stack.length - 1].toString() + '</font></u>';
					trace(stack[stack.length - 1].toString());
					stack[stack.length - 1].firstChild.visited = true;
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "P") {
					if (pCount == 0) {
						if (bCount == 0) {
							myText += '<br><br>';
						} else if (bCount == 1) {
							myText += '<br>';
						}
						pCount = 1;
						bCount = 2;
					}
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "BR") {
					if (bCount < 2) {
						myText += '<br>';
						bCount++;
					} else {
						pCount = 1;
					}
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "TITLE") {
					stack[stack.length - 1].firstChild.visited = true;
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "STYLE") {
					stack[stack.length - 1].firstChild.visited = true;
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "APPLET") {
					myText += '<br><u><font color="#0066CC"><a href="' + HTMLUrl + '" target="_blank">Java applet detected on html</a></font></u><br>';
					bCount++;
					stack[stack.length - 1].firstChild.visited = true;
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "OBJECT") {
					myText += '<br><u><font color="#0066CC"><a href="' + HTMLUrl + '" target="_blank">Object detected on html</a></font></u><br>';
					bCount++;
					stack[stack.length - 1].firstChild.visited = true;
				}
				if (stack[stack.length - 1].nodeName.toUpperCase() == "IMG" || stack[stack.length - 1].nodeName.toUpperCase() == "MYIMG") {
					var imageUrl = stack[stack.length - 1].attributes.src;
					var fileDot = imageUrl.lastIndexOf(".");
					var fileType = imageUrl.substring(fileDot + 1, imageUrl.length).toUpperCase();
					if (fileType == "JPG" || fileType == "JPEG" || fileType == "SWF") {
						if (imageUrl.substring(0, 4).toUpperCase() == "HTTP") {
							imageStack.push(imageUrl);
						} else {
							imageStack.push(HTMLUrlFolder + imageUrl);
						}
					}
					//trace(imageStack[imageStack.length-1]);
				}
			}
			// Parse text here
			if (stack[stack.length - 1].nodeType == 3) {
				if (firstText) {
					if (removeWhiteSpace(stack[stack.length - 1].nodeValue.substr(0, 5)) != " &lt;") {
						myText += '<b>' + stack[stack.length - 1].nodeValue + '</b>';
						firstText = false;
					}
				} else {
					myText += stack[stack.length - 1].nodeValue;
				}
				pCount = 0;
				bCount = 0;
			}
			// Continue search
			if (stack[stack.length - 1].firstChild != null && !stack[stack.length - 1].firstChild.visited) {
				stack[stack.length - 1].firstChild.visited = true;
				stack.push(stack[stack.length - 1].firstChild);
				continue;
			}
			if (stack[stack.length - 1].nextSibling != null && !stack[stack.length - 1].nextSibling.visited) {
				stack[stack.length - 1].nextSibling.visited = true;
				stack[stack.length - 1] = stack[stack.length - 1].nextSibling;
				continue;
			}
			stack.pop();
		}
		myText += "</font>";
		// Clean up that crap and send it to the objects
		myText = removeWhiteSpace(myText);
		//trace(myText);
		//trace(imageStack.toString());
		this["textAreaBox"].setText(myText);
		if (imageStack.length > 0) {
			this["carouselControl"].loadControl(imageStack);
		}
	}
	function removeWhiteSpace(string:String) { // <- DEPRECATED
		// replace various whitespace characters with standard whitespace
		var stringArray = new Array();
		stringArray = string.split("\n");
		string = stringArray.join(" ");
		stringArray = string.split("\t");
		string = stringArray.join(" ");
		stringArray = string.split("\r");
		string = stringArray.join(" ");
		// Shrink areas of white space to one character
		// For some unknown reason, a double sweep of the string needs to be done.
		var white = -1;
		var count = 1;
		for (var j = 0; j < 2; j++) {
			for (var i = 0; i < string.length; i++) {
				var myChar = string.charAt(i);
				if (myChar == " ") {
					if (white < 0) {
						white = i;
					} else {
						count++;
					}
				} else if (white > 0) {
					string = string.substr(0, white) + " " + string.substr(white + count);
					white = -1;
					count = 1;
				}
			}
		}
		// Clip space from right ending tags
		var lastChar = "";
		for (var i = 0; i < string.length; i++) {
			var myChar = string.charAt(i);
			if (myChar == " ") {
				if (lastChar == ">") {
					string = string.substr(0, i) + string.substr(i + 1);
				}
			}
			if (string.substr(i, 4).toUpperCase() == "</A>") {
				if (lastChar == " ") {
					string = string.substr(0, i - 1) + string.substr(i);
				}
			}
			if (string.substr(i - 17, 15).toUpperCase() == "</A></FONT></U>") {
				string = string.substr(0, i - 2) + " " + string.substr(i - 2);
			}
			lastChar = myChar;
		}
		return string;
	}
}
