﻿// GUI for controlling and saving layout
//
class LayoutControl extends MovieClip {
	var fill:Number;
	var over:Number;
	var textFill:Number;
	var xmlID:XMLNode;
	var tab:Array;
	var asset:MovieClip;
	var ready:Boolean = false;
	// init
	function setLayoutControl(temp:XMLNode, asset:MovieClip) {
		xmlID = temp;
		this.asset = asset;
		_x = parseInt(xmlID.attributes.x);
		_y = parseInt(xmlID.attributes.y);
		fill = parseInt(xmlID.attributes.boxFill, 16);
		over = parseInt(xmlID.attributes.overFill, 16);
		textFill = parseInt(xmlID.attributes.textFill, 16);
		attachMovie("TextBox", "label", this.getNextHighestDepth(), {_y:20});
		this["label"].setText("Layout Control", fill, over, textFill);
		tab = new Array();
		setTabs();
		this._visible = false;
		_parent["consoleBox"].report("LayoutControl mounted and initialised");
		ready = true;
	}
	// Set buttons
	function setTabs() {
		var n = 0;
		for (i in tab) {
			tab[i].removeMovieClip();
		}
		tab = new Array();
		// boxFill tab
		tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
		tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
		tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
		tab[tab.length - 1]["textInput"].setSize(50, 20);
		tab[tab.length - 1]["textInput"].text = string16(asset.fill);
		tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
		mySetNewTextFormat(tab[tab.length - 1]["txt"]);
		tab[tab.length - 1]["txt"].embedFonts = true;
		tab[tab.length - 1]["txt"].text = "boxFill";
		tab[tab.length - 1]["e"] = new Object();
		// Event Listener
		tab[tab.length - 1]["e"]["parent"] = this;
		tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
		tab[tab.length - 1]["e"].enter = function(eventObj) {
			//trace(this["textInput"].text);
			this["parent"].asset.fill = parseInt(this["textInput"].text, 16);
			this["parent"].asset.reDraw();
			if (this["parent"] instanceof LayoutBox) {
				this["parent"].grid();
			}
		};
		tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		// html background color tab
		if (asset instanceof LayoutBox) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
			tab[tab.length - 1]["textInput"].setSize(50, 20);
			tab[tab.length - 1]["textInput"].text = string16(asset.htmlColor);
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "html color";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
			tab[tab.length - 1]["e"].enter = function(eventObj) {
				this["parent"].asset.htmlColor = parseInt(this["textInput"].text, 16);
				this["parent"].asset.reDraw();
				var colTemp = this["parent"].string16(this["parent"].asset.htmlColor);
				this["parent"].getURL("javascript:changeBg('#" + colTemp + "');", "_self");
			};
			tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		}
		// applet border color tab
		if (asset instanceof LayoutBox) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
			tab[tab.length - 1]["textInput"].setSize(50, 20);
			tab[tab.length - 1]["textInput"].text = string16(asset.appletCol);
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "applet color";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
			tab[tab.length - 1]["e"].enter = function(eventObj) {
				this["parent"].asset.appletCol = parseInt(this["textInput"].text, 16);
				var colTemp = this["parent"].string16(this["parent"].asset.appletCol);
				this["parent"].getURL("javascript:setAppletBorder('appletborder','#" + colTemp + "');", "_self");
			};
			tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		}
		// overFill tab
		if (asset.over != null) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
			tab[tab.length - 1]["textInput"].setSize(50, 20);
			tab[tab.length - 1]["textInput"].text = string16(asset.over);
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "overFill";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
			tab[tab.length - 1]["e"].enter = function(eventObj) {
				this["parent"].asset.over = parseInt(this["textInput"].text, 16);
				this["parent"].asset.reDraw();
			};
			tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		}
		// shadeFill tab
		if (asset.shade != null) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
			tab[tab.length - 1]["textInput"].setSize(50, 20);
			tab[tab.length - 1]["textInput"].text = string16(asset.shade);
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "shadeFill";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
			tab[tab.length - 1]["e"].enter = function(eventObj) {
				this["parent"].asset.shade = parseInt(this["textInput"].text, 16);
				this["parent"].asset.reDraw();
			};
			tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		}
		// arrowFill tab
		if (asset.arrowFill != null) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
			tab[tab.length - 1]["textInput"].setSize(50, 20);
			tab[tab.length - 1]["textInput"].text = string16(asset.arrowFill);
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "arrowFill";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
			tab[tab.length - 1]["e"].enter = function(eventObj) {
				this["parent"].asset.arrowFill = parseInt(this["textInput"].text, 16);
				this["parent"].asset.reDraw();
			};
			tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		}
		// textFill tab
		if (asset.textFill != null) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("TextInput", "textInput", 3);
			tab[tab.length - 1]["textInput"].setSize(50, 20);
			tab[tab.length - 1]["textInput"].text = string16(asset.textFill);
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "textFill";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["textInput"] = tab[tab.length - 1]["textInput"];
			tab[tab.length - 1]["e"].enter = function(eventObj) {
				this["parent"].asset.textFill = parseInt(this["textInput"].text, 16);
				this["parent"].asset.reDraw();
			};
			tab[tab.length - 1]["textInput"].addEventListener("enter", tab[tab.length - 1]["e"]);
		}
		// MenuBox orient tab
		if (asset instanceof MenuBox) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			asset.textFill.toString(16);
			tab[tab.length - 1].createTextField("txt", 5, 0, 0, 100, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "Orient:" + asset.orient;
			tab[tab.length - 1]["parent"] = this;
			tab[tab.length - 1].onRollOver = function() {
				this.drawBox(over);
			};
			tab[tab.length - 1].onRollOut = function() {
				this.drawBox(fill);
			};
			tab[tab.length - 1].onRelease = function() {
				switch (this["parent"].asset.orient) {
				case "v" :
					this["parent"].asset.setOrient("h");
					break;
				case "h" :
					this["parent"].asset.setOrient("v");
					break;
				}
				this["txt"].text = "Orient:" + this["parent"].asset.orient;
			};
		}
		// w tab
		if (asset.w != null) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("NumericStepper", "numericStepper", 3);
			tab[tab.length - 1]["numericStepper"].setSize(50, 20);
			tab[tab.length - 1]["numericStepper"].value = asset.w;
			tab[tab.length - 1]["numericStepper"].stepSize = 1;
			tab[tab.length - 1]["numericStepper"].minimum = 0;
			tab[tab.length - 1]["numericStepper"].maximum = 800;
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "width";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["numericStepper"] = tab[tab.length - 1]["numericStepper"];
			tab[tab.length - 1]["e"].change = function(eventObj) {
				this["parent"].asset.w = this["numericStepper"].value;
				this["parent"].asset.reDraw();
			};
			tab[tab.length - 1]["numericStepper"].addEventListener("change", tab[tab.length - 1]["e"]);
			tab[tab.length - 1]["numericStepper"].value = asset.w;
		}
		// h tab
		if (asset.h != null) {
			tab.push(attachMovie("Box", "tab" + (n++), this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("NumericStepper", "numericStepper", 3);
			tab[tab.length - 1]["numericStepper"].setSize(50, 20);
			tab[tab.length - 1]["numericStepper"].stepSize = 1;
			tab[tab.length - 1]["numericStepper"].minimum = 0;
			tab[tab.length - 1]["numericStepper"].maximum = 600;
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "height";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["numericStepper"] = tab[tab.length - 1]["numericStepper"];
			tab[tab.length - 1]["e"].change = function(eventObj) {
				this["parent"].asset.h = this["numericStepper"].value;
				this["parent"].asset.reDraw();
			};
			tab[tab.length - 1]["numericStepper"].addEventListener("change", tab[tab.length - 1]["e"]);
			tab[tab.length - 1]["numericStepper"].value = asset.h;
		}
		// x tab
		if (!(asset instanceof LayoutBox) && !(asset instanceof LayoutControl)) {
			tab.push(attachMovie("Box", "xPos", this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("NumericStepper", "numericStepper", 3);
			tab[tab.length - 1]["numericStepper"].setSize(50, 20);
			tab[tab.length - 1]["numericStepper"].value = asset._x;
			tab[tab.length - 1]["numericStepper"].stepSize = 1;
			tab[tab.length - 1]["numericStepper"].minimum = 0;
			tab[tab.length - 1]["numericStepper"].maximum = Stage.width;
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "x pos";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["numericStepper"] = tab[tab.length - 1]["numericStepper"];
			tab[tab.length - 1]["e"].change = function(eventObj) {
				this["parent"].asset._x = this["numericStepper"].value;
			};
			tab[tab.length - 1]["numericStepper"].addEventListener("change", tab[tab.length - 1]["e"]);
		}
		// y tab
		if (!(asset instanceof LayoutBox) && !(asset instanceof LayoutControl)) {
			tab.push(attachMovie("Box", "yPos", this.getNextHighestDepth()));
			tab[tab.length - 1].setBox(0, 0, 100, 20, fill, over);
			tab[tab.length - 1].attachMovie("NumericStepper", "numericStepper", 3);
			tab[tab.length - 1]["numericStepper"].setSize(50, 20);
			tab[tab.length - 1]["numericStepper"].value = asset._y;
			tab[tab.length - 1]["numericStepper"].stepSize = 1;
			tab[tab.length - 1]["numericStepper"].minimum = 0;
			tab[tab.length - 1]["numericStepper"].maximum = Stage.width;
			tab[tab.length - 1].createTextField("txt", 5, 50, 0, 50, 20);
			mySetNewTextFormat(tab[tab.length - 1]["txt"]);
			tab[tab.length - 1]["txt"].embedFonts = true;
			tab[tab.length - 1]["txt"].text = "y pos";
			tab[tab.length - 1]["e"] = new Object();
			// Event Listener
			tab[tab.length - 1]["e"]["parent"] = this;
			tab[tab.length - 1]["e"]["numericStepper"] = tab[tab.length - 1]["numericStepper"];
			tab[tab.length - 1]["e"].change = function(eventObj) {
				this["parent"].asset._y = this["numericStepper"].value;
			};
			tab[tab.length - 1]["numericStepper"].addEventListener("change", tab[tab.length - 1]["e"]);
		}
		tab.push(attachMovie("TextBox", "saveBox", this.getNextHighestDepth()));
		tab[tab.length - 1].setText("save & relaunch", fill, over, textFill);
		tab[tab.length - 1]["parent"] = this;
		tab[tab.length - 1].onRollOver = function() {
			this.drawBox(over);
		};
		tab[tab.length - 1].onRollOut = function() {
			this.drawBox(fill);
		};
		tab[tab.length - 1].onRelease = function() {
			this["parent"].saveXML();
		};
		for (var i = 0; i < tab.length; i++) {
			tab[i]._x -= 50;
			if (i == 0) {
				tab[i]._y = this["label"]._y + this["label"].hh();
			} else if (i < tab.length - 1) {
				tab[i]._y = tab[i - 1]._y + tab[i - 1].bh();
			} else {
				tab[i]._x += 50;
				tab[i]._y = tab[i - 1]._y + tab[i - 1].bh() + tab[i].hh();
			}
		}
	}
	// Feedback from movement of Handles
	function updateXY(x:Number, y:Number) {
		this["xPos"]["numericStepper"].value = x;
		this["yPos"]["numericStepper"].value = y;
	}
	function reDraw() {
		this["label"].setText("Layout Control", fill, over, textFill);
		setTabs();
	}
	function designate(yes:Boolean) {
		this["label"].designate(yes);
	}
	function saveXML() {
		var XMLFile = new XML();
		var myXMLNode = XMLFile.createElement("layout");
		var childNode = XMLFile.createElement("default");
		childNode.attributes.boxFill = string16(_parent.fill);
		childNode.attributes.bgCol = string16(_parent.htmlColor);
		childNode.attributes.appletCol = string16(_parent.appletCol);
		myXMLNode.appendChild(childNode);
		childNode = null;
		for (var i = 0; i < _parent.asset.length; i++) {
			var asset = _parent.asset[i];
			if (asset instanceof MenuBox) {
				childNode = XMLFile.createElement("menubox");
				childNode.attributes.overFill = string16(asset.over);
				childNode.attributes.textFill = string16(asset.textFill);
				childNode.attributes.orient = asset.orient;
			}
			if (asset instanceof CarouselBox) {
				childNode = XMLFile.createElement("carouselbox");
				childNode.attributes.shadeFill = string16(asset.shade);
			}
			if (asset instanceof CarouselControl) {
				childNode = XMLFile.createElement("carouselcontrol");
				childNode.attributes.overFill = string16(asset.over);
				childNode.attributes.arrowFill = string16(asset.arrowFill);
			}
			if (asset instanceof TextAreaBox && !(asset instanceof ConsoleBox)) {
				childNode = XMLFile.createElement("textareabox");
				childNode.attributes.overFill = string16(asset.over);
				childNode.attributes.arrowFill = string16(asset.arrowFill);
				childNode.attributes.shadeFill = string16(asset.shade);
				childNode.attributes.w = asset.w;
				childNode.attributes.h = asset.h;
			}
			if (asset == this) {
				childNode = XMLFile.createElement("layoutcontrol");
				childNode.attributes.overFill = string16(asset.over);
				childNode.attributes.textFill = string16(asset.textFill);
			}
			if(childNode != null){
				childNode.attributes.x = asset._x;
				childNode.attributes.y = asset._y;
				childNode.attributes.boxFill = string16(asset.fill);
				myXMLNode.appendChild(childNode);
			}
		}
		XMLFile.appendChild(myXMLNode);
		XMLFile.contentType = "text/xml";
		XMLFile.send("portfolio.php", "_self");
		//trace(XMLFile.toString());
	}
	function mySetNewTextFormat(myText:TextField) {
		var tf = new TextFormat();
		tf.font = "Default";
		tf.size = "12";
		tf.align = "center";
		tf.color = textFill;
		myText.setNewTextFormat(tf);
	}
	// Flash trims the zeros that html needs to see - this gives 6 digit hex strings
	function string16(num:Number){
		var string = num.toString(16);
		while(string.length < 6){
			string = "0" + string;
		}
		return string;
	}
}
