﻿class MenuBox extends MovieClip{
	var tab:Array;
	var focus:Number = -1;
	var orient:String;
	var space:Number = 10;
	var designated:Boolean = false;
	var fill:Number;
	var over:Number;
	var textFill:Number;
	var web2:Boolean;
	var xmlID:XMLNode;
	var ready:Boolean = false;
	function setContent(contentXML:XML, temp:XMLNode){
		xmlID = temp;
		_x = parseInt(xmlID.attributes.x);
		_y = parseInt(xmlID.attributes.y);
		fill = parseInt(xmlID.attributes.boxFill, 16);
		over = parseInt(xmlID.attributes.overFill, 16);
		textFill = parseInt(xmlID.attributes.textFill, 16);
		orient = xmlID.attributes.orient;
		contentXML.ignoreWhite = true;
		var rootNode = contentXML.firstChild;
		if(rootNode.nodeName.toUpperCase() == "MENU"){
			tab = new Array();
			var tabNode = rootNode.firstChild;
			var n = 0;
			while(tabNode != null){
				tab.push(attachMovie("TextBox", "textBox"+(n++), this.getNextHighestDepth()));
				tab[tab.length-1].setText(tabNode.attributes.id, fill, over, textFill);
				if(tabNode.attributes.url != null){
					tab[tab.length - 1].url = tabNode.attributes.url;
				}
				var p = new Array();
				var pNode = tabNode.firstChild;
				while(pNode != null){
					p.push(attachMovie("TextBox", "textBox"+(n++), this.getNextHighestDepth()));
					p[p.length - 1].setText(pNode.attributes.id, fill, over, textFill);
					p[p.length - 1].url = pNode.attributes.url;
					// Project button interaction
					p[p.length - 1].onRelease = function() {
						_parent._parent.myGetUrl(this.url);
						this._parent.changeFocus(-1);
					};
					p[p.length - 1].onRollOver = function(){
						this.drawBox(this.over);
					};
					p[p.length - 1].onRollOut = function(){
						this.drawBox(this.fill);
					};
					p[p.length - 1]._visible = false;
					p[p.length - 1]._alpha = 0;
					pNode = pNode.nextSibling;
				}
				tab[tab.length - 1].project = new Array();
				tab[tab.length - 1].project = p;
				tab[tab.length - 1].num = tab.length - 1;
				tab[tab.length - 1].giveFocus = function() {
					for (var i = 0; i < this.project.length; i++) {
						this.project[i]._alpha = 0;
						this.project[i]._visible = true;
						var time = 0.5;
						var fade = new mx.transitions.Tween(this.project[i], "_alpha", mx.transitions.easing.Strong.easeIn, 0, 100, time, true);
					}
				}
				tab[tab.length - 1].loseFocus = function() {
					for (var i = 0; i < this.project.length; i++) {
						var time = 0.5;
						var fade = new mx.transitions.Tween(this.project[i], "_alpha", mx.transitions.easing.Strong.easeIn, 100, 0, time, true);
						fade["myClip"] = this.project[i];
						fade.onMotionFinished = function(){
							this["myClip"]._visible = false;
						};
					}
				}
				// Menu tab interaction
				tab[tab.length - 1].onRelease = function() {
					this._parent.changeFocus(this.num);
				};
				tab[tab.length - 1].onRollOver = function() {
					this.drawBox(this.over);
				};
				tab[tab.length - 1].onRollOut = function() {
					this.drawBox(this.fill);
				};
				tabNode = tabNode.nextSibling;
			}
			this.orient = orient;
			setOrient(orient);
			_parent["consoleBox"].report("MenuBox mounted and initialised");
			ready = true;
		}
	}
	function designate(yes:Boolean){
		for(var i in tab){
			tab[i].designate(yes);
			for(var j in tab[i].project){
				tab[i].project[j].designate(yes);
			}
		}
		designated = yes;
	}
	function reDraw(){
		for(var i in tab){
			tab[i].setText(tab[i].id, fill, over, textFill);
			for(var j in tab[i].project){
				tab[i].project[j].setText(tab[i].project[j].id, fill, over, textFill);
			}
		}
	}
	function changeFocus(n:Number){
		if (tab[n].url != null) {
			_parent.myGetUrl(tab[n].url);
		}
		if (n != focus) {
			tab[focus].loseFocus();
			tab[n].giveFocus();
			focus = n;
		}
	}
	function setOrient(orient:String){
		this.orient = orient;
		switch(orient){
			case "v":
				for(var i = 0; i < tab.length; i++){
					tab[i]._x = -tab[i].hw();
					tab[i]._y = tab[i].hh();
					if(i > 0){
						tab[i]._y = space + tab[i-1]._y + tab[i-1].hh() + tab[i].hh();
					}
					for(var j = 0; j < tab[i].project.length; j++){
						tab[i].project[j]._x = space + tab[i].project[j].hw();
						tab[i].project[j]._y = tab[i]._y;
						if(j > 0){
							tab[i].project[j]._y = space + tab[i].project[j-1]._y + tab[i].project[j-1].hh() + tab[i].hh();
						}
					}
				}
				break;
			case "h":
				for(var i = 0; i < tab.length; i++){
					tab[i]._x = tab[i].hw();
					tab[i]._y = tab[i].hh();
					if(i > 0){
						tab[i]._x = space + tab[i-1]._x + tab[i-1].hw() + tab[i].hw();
					}
					for(var j = 0; j < tab[i].project.length; j++){
						tab[i].project[j]._x = tab[i]._x - tab[i].hw()  + tab[i].project[j].hw();
						tab[i].project[j]._y = space + tab[i].bh() + tab[i].project[j].hh();
						if(j > 0){
							tab[i].project[j]._y = space + tab[i].project[j-1]._y + tab[i].project[j-1].hh() + tab[i].hh();
						}
					}
				}
				break;
		}
	}
}