﻿class StripWhite{
// Function: stripWhitespaceTraverse()
//  Version: 1.0.1
//     Desc: Strips whitespace nodes from an 
//           XML document by traversing the tree
//url:
function stripWhitespaceTraverse(XMLnode) {
	// Create a list of nodes to process
	var nodeList = new Array();
	// Seed the list with the node passed to the function
	nodeList[0] = XMLnode;
	// Create a local variable to track whether we've
	// found an empty node.
	var emptyNode;
	// Local counter variable.
	var i = 0;
	// Process the passed node and its descendents until
	// there are none left to process
	while (nodeList.length > 0) {
		// Grab the first node on the list, and remove it from the list
		currentNode = nodeList.shift();
		// Assume we're dealing with a non-empty node.
		emptyNode = false;
		// If this node has children...
		if (currentNode.childNodes.length > 0) {
			// ...add this node's children to the list of nodes to process
			nodeList = nodeList.concat(currentNode.childNodes);
		} else {
			// ...otherwise, this node is the end of a branch, so check if it's a
			// text node...
			if (currentNode.nodeType == 3) {
				// Yup, it's a text node, so check if it only contains empty whitespace.
				// Assume it's only whitespace and try to prove the assumption wrong.
				emptyNode = true;
				for (i = 0; i < currentNode.nodeValue.length; i++) {
					// A useful character is anything over 32 (space,
					// tab, new line, etc are all below).
					if (currentNode.nodeValue.charCodeAt(i) > 32) {
						emptyNode = false;
						break;
					}
				}
			}
			// If no useful charaters were found, delete the node		
			if (emptyNode) {
				currentNode.removeNode();
			}
		}
	}
}
}