﻿// Replacement for default TextArea component
//
class TextAreaBox extends Box {
	public var txtCol:Number;
	var minH:Number = space;
	var w:Number;
	var h:Number;
	var arrowFill:Number;
	var txtSize:Number = 14;
	var ready:Boolean = false;
	var mouseListener:Object;
	var css:TextField.StyleSheet;
	// init
	function setArea(temp:XMLNode) {
		xmlID = temp;
		w = parseInt(xmlID.attributes.w);
		h = parseInt(xmlID.attributes.h);
		_x = parseInt(xmlID.attributes.x);
		_y = parseInt(xmlID.attributes.y);
		fill = parseInt(xmlID.attributes.boxFill, 16);
		over = parseInt(xmlID.attributes.overFill, 16);
		shade = parseInt(xmlID.attributes.shadeFill, 16);
		arrowFill = parseInt(xmlID.attributes.arrowFill, 16);
		setTextArea();
		mouseListener = new Object();
		mouseListener["box"] = this;
		mouseListener.onMouseWheel = function(d:Number) {
			if (this["box"]._xmouse < this["box"].hw() && this["box"]._ymouse < this["box"].hh() && this["box"]._xmouse > -this["box"].hw() && this["box"]._ymouse > -this["box"].hh()) {
				this["box"].moveSlide(-d, this["box"]["slide"], this["box"]["txt"]);
			}
		};
		Mouse.addListener(mouseListener);
		css = _parent.css;
		_parent["consoleBox"].report("TextAreaBox mounted and initialised");
		ready = true;
	}
	function setTextArea() {
		createTextField("txt", 3, -w * 0.5, -h * 0.5, w, h);
		this["txt"].mouseWheelEnabled = false;
		this["txt"].multiline = true;
		this["txt"].wordWrap = true;
		this["txt"].background = true;
		this["txt"].html = true;
		setBox(-space - w * 0.5, -space - h * 0.5, (space * 3) + 20 + w, (space * 2) + h, fill, over);
		attachMovie("SliderBox", "slide", 5, {_x:hw() - (space * 0.5)});
		this["slide"].setBox(-10, -hh() + space + 20, 20, bh() - (space * 2) - 40, shade, shade);
		this["slide"].setSlider(arrowFill, over, this["txt"].scroll, this["txt"].maxscroll, true);
		attachMovie("ArrowBox", "up", 7, {_x:hw() - (space * 0.5), _y:-hh() + 20, useHandCursor:false});
		this["up"].setBox(-10, -10, 20, 20, fill, over);
		this["up"].setArrow("up", arrowFill);
		attachMovie("ArrowBox", "down", 9, {_x:hw() - (space * 0.5), _y:hh() - 20, useHandCursor:false});
		this["down"].setBox(-10, -10, 20, 20, fill, over);
		this["down"].setArrow("down", arrowFill);
	}
	function reDraw() {
		setTextArea();
	}
	function setText(string:String) {
		this["txt"].htmlText = "<body>"+string+"</body>";
		this["txt"].styleSheet = css;
		this["slide"].setLength(this["txt"].scroll, this["txt"].maxscroll, txtSize);
		this["slide"].bar.onMouseMove = function() {
			_parent._parent["txt"].scroll = _parent.getPos();
		};
		this["slide"].track.onPress = function() {
			this["bar"]._y = _ymouse - this["bar"].hh();
			if (this["bar"]._y > _parent.max_y) {
				this["bar"]._y = _parent.max_y;
			}
			if (this["bar"]._y < _parent.min_y) {
				this["bar"]._y = _parent.min_y;
			}
			_parent._parent["txt"].scroll = _parent.getPos();
		};
		this["up"].onPress = function() {
			_parent.moveSlide(-2, _parent["slide"], _parent["txt"]);
			//_parent["slide"]["bar"]._y = Math.max(_parent["slide"]["bar"]._y - _parent["slide"].unitHeight, _parent["slide"].min_y);
			//_parent["txt"].scroll -= 1;
		};
		this["down"].onPress = function() {
			_parent.moveSlide(2, _parent["slide"], _parent["txt"]);
			//_parent["slide"]["bar"]._y = Math.min(_parent["slide"]["bar"]._y + _parent["slide"].unitHeight, _parent["slide"].max_y);
			//_parent["txt"].scroll += 1;
		};
	}
	function moveSlide(units:Number, slide:MovieClip, txt:TextField) {
		if(units > 0){
			slide.bar._y = Math.min(slide.bar._y + slide.unitHeight * units, slide.max_y);
			txt.scroll += units;
		} else if(units < 0){
			slide.bar._y = Math.max(slide.bar._y + slide.unitHeight * units, slide.min_y);
			txt.scroll += units;
		}
	}
}
