<?
/**
 * HTML to XML Parser Class
 *
 * @author Jan Marsch <jama@keks.com>
 * @version 0.2.0 2003-02-25 23:12
 * @copyright (c)2003 Jan Marsch
 */

class html2xml extends xml{

	function &parse($string){
		$singletags = array("area", "br", "col", "frame", "hr", "iframe", "img", "myimg", "input", "link", "meta", "p", "param");
		$chunks = preg_split('|(<[^>]+>)|s', $string, "", PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);

		$level = 0;
		$stack = array();

		$stack[$level] =& $this->createElement("root", null);

		for($c = 0; $c < count($chunks); $c++){
			if(trim($chunks[$c]) == "") continue;

			//****** check for tag, text/comment, close, attributes ******
			preg_match("/^<([\/!])?([\w]+)(.*)>$/s", $chunks[$c], $match);

			//****** is text/comment ******
			if(!$match[0] || $match[1] == "!"){
				if(trim($chunks[$c]) == "") continue;
				$text =& $this->createTextNode($chunks[$c]);
				$stack[$level]->appendChild(&$text);
				continue;
				}

			$name = strtolower($match[2]);

			//****** close existing tag ******
			if($match[1] == "/"){
				unset($found);
				for($i = count($stack)-1; $i >= 0; $i--){
					if($stack[$i]->nodeName == $name){
						$found = $i;
						break;
						}
					}

				if(isset($found)){
					for($level; $level >= $found; $level--){
						$stack[$level-1]->appendChild(&$stack[$level]);
						$this->nodes[] =& array_pop($stack);
						}
					}

				continue;
				}

			//****** create open tag ******
			preg_match_all('|[\s]+([\w-]+)([\s]*=[\s]*("([^"]*)")?([\S]*))?|', $match[3], $match, PREG_PATTERN_ORDER);

			$attributes = array();
			for($i = 0; $i < count($match[0]); $i++){
				if($match[4][$i] || is_numeric($match[4][$i]))	$attributes[strtolower($match[1][$i])] = $match[4][$i];
				else											$attributes[strtolower($match[1][$i])] = $match[5][$i];
				}

			$level++;
			$stack[$level] =& $this->createElement($name);
			$stack[$level]->attributes = $attributes;

			//****** complete known single tags ******
			if(in_array($name, $singletags)){
				$stack[$level-1]->appendChild(&$stack[$level]);
				$this->nodes[] =& array_pop($stack);
				$level--;
				continue;
				}
			}

		//****** close possible open tags ******

		for($i = count($stack)-1; $i > 0; $i--){
			$stack[$level-1]->appendChild(&$stack[$level]);
			$this->nodes[] =& array_pop($stack);
			$level--;
			}

		$root =& $stack[$level];
		$root->parentNode = null;
		return $root;
		}
	}
?>